#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pygame
from pygame.locals import *

from pgu import gui

from modules.gui6 import AboutDialog
from modules.gui7 import ColorDialog
from modules.gui8 import NewDialog

from modules.dialogs import *

from modules.diccio import llenar


if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'

# Partimos con las constantes
from modules.const import *
from modules.classe import *

import tarfile
import shutil
import Image

ruta='void'
TAM_PANT=640,480
screen = pygame.display.set_mode(TAM_PANT, HWSURFACE)
pygame.display.set_caption('KSplasher v0.9.8 BETA')

class Painter(gui.Widget):
    def __init__(self,da,**params):
        gui.Widget.__init__(self,**params)
        self.surface = None
        self.state = 0
        self.style.width,self.style.height=1600,1200
        self.xabs,self.yabs=0,0
        self.botones=0

    def init(self,ru):
        self.tema, self.RC = cargar_tema(ru)#cargamos el tema
        res=self.RC['BaseResolution'].split(',')
        try: self.fondo = cargar_imagen(self.RC['Background'],None,ru)
        except:# Nos aseguramos que tengamos fondo
            try: self.fondo = cargar_imagen('background.jpg',None,ru)
            except:
                try: self.fondo = cargar_imagen('Background.jpg',None,ru)
                except: self.fondo = None

        try:TP1=TP=self.fondo[0].get_size()# creamos tamano del fondo
        except: TP1=TP=int(res[0]),int(res[1])
        TP=TP[0]+1,TP[1]+26
        screen = pygame.display.set_mode(TP, 0)
        self.surface = pygame.Surface(TP1,pygame.SRCALPHA,32)

        try:self.surface.blit(self.fondo[0],(0,0))# Llenamos el fondo
        except: self.surface.fill((0,0,0))
        
        self.da=datos
        self.ru=ru
        self.overlay = pygame.Surface(TP,pygame.SRCALPHA,32)# Overlay es la capa de trabajo

        self.repaint()
        
    def event(self,e):
        if not self.surface: return
        
        if e.type == gui.MOUSEBUTTONDOWN:
            self.botones=1
            self.mover_elem(e)
        if e.type == gui.MOUSEMOTION:
            self.mover_elem(e)
        if e.type is gui.MOUSEBUTTONUP:
            self.botones=0

    
    def paint(self,s): # se llama con self.repaint()
        s.blit(self.surface,(0,0)) # pintamos el fondo
        self.tema.draw(self.overlay) # dibujamos el tema en  la capa overlay
        s.blit(self.overlay,(0,0)) # pintamos el overlay
                            
    def mover_elem(self,e):
        x_abs, y_abs = pygame.mouse.get_pos()  #posicion absoluta del mouse
        x_rel, y_rel = pygame.mouse.get_rel() #posicion relativa del mouse
        self.tema.update(x_abs-1,y_abs-26,x_rel,y_rel,self.botones)
        self.overlay.fill((0,0,0,0))
        self.repaint()
        
    def alinear_y(self,var):# Alinear en Y
        sep = var
        x=range(len(coordenadas))
        x.remove(x[-1])
        for i in x:
            coordenadas[i+1]=coordenadas[0][0],coordenadas[0][1]+sep
            sep=sep+var
        for i in self.tema:
            try:i.rect.x,i.rect.y=coordenadas[iconos.index(i.ar)]
            except: pass
        self.overlay.fill((0,0,0,0))
        self.repaint()
        
    def alinear_x(self,var):# Alinear en X
        sep = var
        y=range(len(coordenadas))
        y.remove(y[-1])
        for i in y:
            coordenadas[i+1]=coordenadas[0][0]+sep,coordenadas[0][1]
            sep=sep+var
        for i in self.tema:
            try:i.rect.x,i.rect.y=coordenadas[iconos.index(i.ar)]
            except: pass
        self.overlay.fill((0,0,0,0))
        self.repaint()

    def guardar(self):
# guardamos el .rc con la info de las coordenadas
        ta=file((os.path.join(self.ru,'Theme.rc')),'w')

        for i in Datos:
            self.RC[i]=self.da[Datos[i]]

        ii='[KSplash Theme'
        self.RC[ii]=' '+self.da[0]+']'
            
        for i in Coord:
            try: # Ingresamos las coordenadas actuales al diccionario de coordenadas
                self.RC[i]=(str(coordenadas[Coord[i]]).strip('(')).strip(')')
            except: pass
            
        try:# Ingresamos coordenadas del status
            self.RC['StatusCoords']=(str(stat[0]).strip('(')).strip(')')
        except: pass

        for i in Labels:
            try:
                self.RC[Labels[i][3]]=(str(lab[Labels[i][0]][2]).strip('(')).strip(')')
            except:pass
            
        for i in RC_ORD:
            try:
                self.RC[i] # vemos si existe la descripcion en el diccionario "RC"
                if i=='[KSplash Theme':
                    ta.write(i+':'+self.RC[i]+'\n')# Generamos el archivo .RC
                else: ta.write(i+'='+self.RC[i]+'\n')# Generamos el archivo .RC
            except: pass
        
        
        

class App(gui.Desktop):
    def __init__(self,**params):
        gui.Desktop.__init__(self,**params)

        self.connect(gui.QUIT,self.quit,None)
        
        c = gui.Container(width=TAM_PANT[0],height=TAM_PANT[1])
#        spacer = 0
##        self.new_d = NewDialog()
##        self.new_d.connect(gui.CHANGE,self.action_new,None)

        self.painter = Painter(datos)
        c.add(self.painter,0,26)
        self.painter.init(ruta)

        self.x_d = VarDialog()
        self.x_d.connect(gui.CHANGE,self.align_x,None)
        self.y_d = VarDialog()
        self.y_d.connect(gui.CHANGE,self.align_y,None)

##        self.save_d = SaveDialog()
##        self.save_d.connect(gui.CHANGE,self.action_saveas,None)

##        self.user_d = UserDialog()
##        self.user_d.connect(gui.CHANGE,self.user_info,None)

        
        self.quit_d = QuitDialog()
        self.quit_d.connect(QUIT,self.quit,None)
        self.browser_d = gui.DirDialog()
        self.browser_d.connect(gui.CHANGE, self.handle_file_browser_closed, None)

        self.targz_open = gui.FileDialog()
        self.targz_open.connect(gui.CHANGE, self.targz_open_browser_closed, None)
        
        self.help_d = HelpDialog()
        self.about_d = AboutDialog()
        self.soon_d = SoonDialog()
        self.no_dir = NoDirDialog()
        self.no_file = NoFileDialog()
        
        self.save_preview_ok = SavePreviewOK()
        self.save_preview_ok.connect(gui.CLOSE, self.action_save_p, None)
        
##        self.create_targz_ok = TarGzOK(self.painter.ru.lstrip('temp/'))
##        self.create_targz_ok.connect(gui.CLOSE, self.action_targz_create, None)

        ##Initializing the Menus, we connect to a number of Dialog.open methods for each of the dialogs.
        ##::
        menus = gui.Menus([
            ('File/New Theme',self.action_new,None),
            ('File/Open Folder',self.browser_d.open,None),
            ('File/Open .tar.gz',self.targz_open.open,None),
            ('File/Exit',self.quit_d.open,None),
            ('Actions/Save Preview',self.save_preview_ok.open,None),
            ('Actions/Create Theme.rc',self.action_saverc,None),
            ('Actions/Create .tar.gz',self.targz_info,None),
            ('Modify/Change Author Info',self.user_info,None),
            ('Modify/Align X',self.x_d.open,None),
            ('Modify/Align Y',self.y_d.open,None),
            ('Help/Help',self.help_d.open,None),
            ('Help/About',self.about_d.open,None),
            ])
        ##
        c.add(menus,0,0)
        menus.rect.w,menus.rect.h = menus.resize()
        
##        self.painter = Painter(datos)
##        c.add(self.painter,0,menus.rect.h)
##        self.painter.init(ruta)
##        print datos
        
        welcome_d = WelcomeDialog()
        self.connect(gui.INIT,welcome_d.open,None)
        
        self.widget = c
        
    def action_new(self,value):
#        self.new_d.close()
        self.fname = 'NEW'
        self.painter.init(self.fname)
#        self.painter.init(self.new_d.value.results())
        
    def action_save_p(self,value):
        self.save_preview_ok.close()
        self.prev = os.path.join(self.painter.ru,'preview.bmp')
        self.painter.surface.blit(self.painter.overlay,(0,0))        
        pygame.image.save(self.painter.surface,self.prev)
        mini=Image.open(self.prev)
        xx=mini.resize((400,300))
        xx.save(os.path.join(self.painter.ru,'Preview.png'))
        os.remove(self.prev)
        self.painter.surface.fill((0,0,0,0))
        self.painter.surface.blit(self.painter.fondo[0],(0,0))
        self.painter.repaint()

        
    def action_saverc(self,value):

        self.painter.guardar()


##        self.fname = self.save_d.value['fname'].value
##        pygame.image.save(self.painter.surface,self.fname)

    def user_info(self, value):## Esto es necesario para usar los datos del "painter" en el app principal.
        self.user_d=UserDialog(self.painter.da[0],self.painter.da[1],self.painter.da[2],self.painter.da[3],self.painter.da[4])
        self.user_d.open()
        self.user_d.connect(gui.CHANGE,self.new_user_info,None)

    def new_user_info(self,value):
        self.user_d.close()
        self.tname = self.user_d.value['tname'].value
        self.description = self.user_d.value['description'].value
        self.version = self.user_d.value['version'].value
        self.author = self.user_d.value['author'].value
        self.homepage = self.user_d.value['homepage'].value
        self.painter.da=[self.tname,self.description,self.version,self.author,self.homepage]

        
        
    def align_x(self,value):
        self.x_d.close()
        var=self.x_d.value['fname'].value
        self.painter.alinear_x(int(var))
    def align_y(self,value):
        self.y_d.close()
        var=self.y_d.value['fname'].value
        self.painter.alinear_y(int(var))

    def action_open(self,value):
        self.open_d.close()
        self.fname = self.open_d.value['fname'].value
        self.painter.init(self.fname)
                

    def handle_file_browser_closed(self,value):
        self.browser_d.close()
        control=0
        self.fname = self.browser_d.value#['fname'].value
        sour=glob.glob(os.path.join(self.fname,'*.*'))
        for arshi in sour:
            if os.path.basename(arshi)=='Theme.rc' or os.path.basename(arshi)=='theme.rc':
                control=1
        if control: self.painter.init(self.fname)
        else:
            print 'not a splash theme dir'
            self.no_dir.open()


#        if dlg.value: input_file.value = dlg.value

    def targz_open_browser_closed(self,value):
        self.targz_open.close()
        control=0
        self.fname = self.targz_open.value#['fname'].value
        try:
            tar = tarfile.open(self.fname)
            tar.extractall('temp')
            for tarinfo in tar:
                if tarinfo.isdir():
                    rut=tarinfo.name
                if os.path.basename(tarinfo.name)=='Theme.rc' or os.path.basename(tarinfo.name)=='theme.rc':
                    control=1
            if control: self.painter.init('temp/%s' %rut)
            else:
                print 'not a splash theme file'
                self.no_file.open()
                pass
        except:
            print 'not a compressed file'
            self.no_file.open()

    def targz_info(self, value):## eliminamos la ruta del nombre para usarlo.
        self.nom=self.painter.da[0]+'.tar.gz'
        self.targz_d=TarGzOK(self.nom)
        self.targz_d.open()
        self.targz_d.connect(gui.CLOSE,self.action_targz_create,None)


    def action_targz_create(self,value):
        self.targz_d.close()
        self.painter.guardar()
        self.action_save_p(None)
        carp=self.painter.da[0]
        shutil.copytree(self.painter.ru,'%s' %carp)
        tar = tarfile.open(self.nom, "w:gz")
        tar.add(carp,os.path.basename(carp))
        tar.close()
        shutil.rmtree(carp)


        
app = App()
app.run()

pygame.quit()
