import pygame, sys, glob, os
from pygame.locals import *
from diccio import llenar
from const import *


class Foto(pygame.sprite.Sprite):

    def __init__(self, pos, archivo, ruta):
        pygame.sprite.Sprite.__init__(self)
        self.image, self.rect = cargar_imagen(archivo,-1,ruta)
        self.ancho, self.alto = self.image.get_size()
        self.ar=archivo
        self.mover = 0
        self.rect.x,self.rect.y = pos
        self.original = self.image  #guardamos en original el valor de la imagen sin escalar
        self.alto_original = self.original.get_height()
        self.ancho_original = self.original.get_width()
        
    def _mover(self,xr,yr):
        self.rect.move_ip(xr,yr)
        self.center =  self.rect.center

    def update(self,x_abs,y_abs,x_rel,y_rel,botones):
        if self.mover: self._mover(x_rel,y_rel)
        if self.rect.collidepoint(x_abs,y_abs) and botones:
            self.mover = 1

        if not botones: self.mover = 0
        
# Actualizamos las coordenadas en la lista        
        for i in iconos:
            if i==self.ar: coordenadas[iconos.index(i)]=self.rect.x,self.rect.y
           
class Texto(pygame.sprite.Sprite):

    def __init__(self, mensaje, pos, fuente, tam, color, num):
        pygame.sprite.Sprite.__init__(self)
        fontobject=pygame.font.Font(fuente, tam)
        stat=fontobject.render(mensaje,1,color)
        self.image, self.rect = stat,stat.get_rect()
        self.ancho, self.alto = self.image.get_size()
        self.mover = 0
        self.num=num
        self.rect.x,self.rect.y = pos
        self.original = self.image  #guardamos en original el valor de la imagen sin escalar
        self.alto_original = self.original.get_height()
        self.ancho_original = self.original.get_width()
        
    def _mover(self,xr,yr):
        self.rect.move_ip(xr,yr)
        self.center =  self.rect.center

    def update(self,x_abs,y_abs,x_rel,y_rel,botones):
        if self.mover: self._mover(x_rel,y_rel)
        if self.rect.collidepoint(x_abs,y_abs) and botones:
            self.mover = 1
        
        if not botones: self.mover = 0
        
# Actualizamos las coordenadas en la lista
        lab[self.num][2]=(self.rect.x,self.rect.y)



class TX_Stat(pygame.sprite.Sprite):

    def __init__(self, mensaje, pos, fuente, tam, color):
        pygame.sprite.Sprite.__init__(self)
        fontobject=pygame.font.Font(fuente, tam)
        stat=fontobject.render(mensaje,1,color)
        self.image, self.rect = stat,stat.get_rect()
        self.ancho, self.alto = self.image.get_size()
        self.mover = 0
        self.rect.x,self.rect.y = pos
        self.original = self.image  #guardamos en original el valor de la imagen sin escalar
        self.alto_original = self.original.get_height()
        self.ancho_original = self.original.get_width()
        
    def _mover(self,xr,yr):
        self.rect.move_ip(xr,yr)
        self.center =  self.rect.center

    def update(self,x_abs,y_abs,x_rel,y_rel,botones):
        if self.mover: self._mover(x_rel,y_rel)
        if self.rect.collidepoint(x_abs,y_abs) and botones:
            self.mover = 1
        
        if not botones: self.mover = 0
# Actualizamos las coordenadas en la lista
        stat[0]=(self.rect.x,self.rect.y)
#        stat[0]=(self.rect.x-(TAM_PANT[0]/2),self.rect.y)

        
def cargar_imagen(nombre, colorkey = False, ruta = ''):    

    nombre_completo = os.path.join(ruta, nombre)
    
    try: imagen = pygame.image.load(nombre_completo)
    except pygame.error, message:
        print 'No se puede cargar la imagen: ', nombre_completo
#        raise SystemExit, message
    
##    imagen = imagen.convert()
##    
##    if(colorkey): 
##        colorkey = imagen.get_at((0,0))
##        imagen.set_colorkey(colorkey, RLEACCEL)
        
    return imagen, imagen.get_rect()


def cargar_tema(ruta=''):

##    reiniciamos las variables (PUTA QUE ME COSTO !!!!)
    for i in range(8):
        try:iconos[i]=''
        except:iconos.append('')
    for i in range(8):
        try:coordenadas[i]=''
        except:coordenadas.append('')
    for i in range(5):
        try:datos[i]=''
        except:datos.append('')
    for i in range(3):
        try:lab[i]=('','','','')
        except:lab.append(('','','',''))
    
        
# Primero ordenamos las imagenes y coordenadas por si en el archivo .rc estan en otro orden    
    try:a=llenar(ruta,'Theme.rc')
    except:a=llenar(ruta,'theme.rc')

    fotosSprite = pygame.sprite.RenderUpdates() # creamos el grupo de las fotos y lo gestionamos con Dirty Rectangles

# aca separamos los datos del .rc en distintas listas
    for i in a:
        if i in Coord:
            coordenadas[Coord[i]]=a[i]
            
        if i in PNG:
            iconos[PNG[i]]=os.path.join(ruta,a[i])

        if i in Datos:
            datos[Datos[i]]=a[i]

        if i in Labels:
            tmp=[]
            rr=range(len(Labels[i]))
            rr.remove(rr[0])
            for j in rr:
                try: tmp.append(a[Labels[i][j]])
                except: tmp.append('')
            lab[Labels[i][0]]=tmp
            
        if i in ST:
            stat[ST[i]]=a[i]

##    if 'Image1' not in a:
##        for i in range(coordenadas):            
##            iconos[i]='IMG/%s.png' % str(i+1)

            
# Eliminar espacios en blanco en lista de COORDENADAS
    j=0
    while j in range(len(coordenadas)):
        for i in coordenadas:
            if i=='':
                coordenadas.remove(i)
                j=0
            else: j=j+1

    if 'Image1' not in a:
        try:
            xxx=pygame.image.load(ruta+'1.png')
            for i in range(len(coordenadas)):            
                iconos[i]=ruta+'/%s.png' % str(i+1)                
        except:
            for i in range(len(coordenadas)):            
                iconos[i]='IMG/%s.png' % str(i+1)

# Lo mismo pero para ICONOS

    j=0
    while j in range(len(iconos)):
        for i in iconos:
            if i=='':
                iconos.remove(i)
                j=0
            else: j=j+1

### Tambien para DATOS
##    j=0
##    while j in range(len(datos)):
##        for i in datos:
##            if i=='':
##                datos.remove(i)
##                j=0
##            else: j=j+1

# Llenamos los SPRITES en el grupo, en la ubicacion que corresponde
    j = 0
    while j in range(len(iconos)):
        for i in coordenadas:
            x,y = i.split(",")
            x,y = int(x),int(y)
            fotosSprite.add(Foto((x,y),iconos[j],''))# Esta es la linea que hace la magia (coord,imagen,ruta)
            j = j+1

# LABELS

    j = 0
    while j in range(len(lab)):
        menso,fu,coor,col=lab[j]
        try:
            x,y = coor.split(",")
            x,y = int(x),int(y)
            try:
                lab_ta=fu.split(",")#Fuente,Tamano,??,Color?(RGB)
                ta=int(lab_ta[1])*2
            except:ta=25
            if col=='': col=Color('white')
            else:
                col_tmp=col.split(',')
                col=(int(col_tmp[0]),int(col_tmp[1]),int(col_tmp[2]))
            if menso=='ML:USER:loginname': menso='guest'
            if menso=='ML:CMD:date': menso='Wed Apr 28 04:55:49 MDT 2008'
            fotosSprite.add(Texto(menso,(x,y),None,ta,col,j))            
        except:pass
        j=j+1

# STATUS
    try:
        x,y=stat[0].split(",")#coordenadas
        x,y = (int(x)),int(y.strip("\n"))
#        x,y = ((TAM_PANT[0]/2)+int(x)),int(y.strip("\n"))
        stat_coord=x,y
    except:stat_coord=0
    try:
        stat_col=stat[1].split(",")#Fuente,Tamano,??,Color?(RGB)
        ta=int(stat_col[1])*2
    except:ta=25
    if stat_coord:
        fotosSprite.add(TX_Stat('KDE is up and running',stat_coord,None,ta,Color('white')))
        
    return fotosSprite,a

