import pygame
from pygame.locals import *

# the following line is not needed if pgu is installed
import sys; sys.path.insert(0, "..")

from pgu import gui
from const import *

class HelpDialog(gui.Dialog):
    def __init__(self,**params):
        title = gui.Label("Help")
        
        doc = gui.Document(width=400)
        
        space = title.style.font.size(" ")
        
        doc.block(align=-1)
        for word in """Soon this will be a decent help screen, by now just play with the menus (They're really easy to use).""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)
        doc.br(space[1])
        
        doc.block(align=-1)    
        for word in """This help isn't really here for any other reason than to have a help dialog.""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)

        gui.Dialog.__init__(self,title,doc)

class SoonDialog(gui.Dialog):
    def __init__(self,**params):
        title = gui.Label("Coming Soon ...")
        
        doc = gui.Document(width=400)
        
        space = title.style.font.size(" ")
        
        doc.block(align=0)
        for word in """This feature will be implemented in the next release of KSplasher.""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)

        gui.Dialog.__init__(self,title,doc)

class NoDirDialog(gui.Dialog):
    def __init__(self,**params):
        title = gui.Label("Incorrect Splash Folder ...")
        
        doc = gui.Document(width=400)
        
        space = title.style.font.size(" ")
        
        doc.block(align=0)
        for word in """This folder is not a Splash Screen theme folder.""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)

        gui.Dialog.__init__(self,title,doc)

class NoFileDialog(gui.Dialog):
    def __init__(self,**params):
        title = gui.Label("Incorrect Splash File ...")
        
        doc = gui.Document(width=400)
        
        space = title.style.font.size(" ")
        
        doc.block(align=0)
        for word in """This file is not a Splash Screen theme file.""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)

        gui.Dialog.__init__(self,title,doc)

class SavePreviewOK(gui.Dialog):
    def __init__(self,**params):
        title = gui.Label("Preview Saved")
        
        doc = gui.Document(width=400)
        
        space = title.style.font.size(" ")

        doc.br(space[1])
        doc.block(align=0)

        for word in """File Preview.bmp created successfully.""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)
        doc.br(space[1])
        
        doc.block(align=0)    
        for word in """Don't forget to GIMP-it and save as preview.PNG to use in your Splash Theme""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)

        doc.br(space[1])
        bot= gui.Button("OK")
        bot.connect(gui.CLICK,self.close,None)
        doc.add(bot,align=0)
        doc.br(space[1])


        gui.Dialog.__init__(self,title,doc)

class TarGzOK(gui.Dialog):
    def __init__(self,nombre,**params):
        title = gui.Label("%s created" %nombre)
        
        doc = gui.Document(width=400)
        
        space = title.style.font.size(" ")

        doc.br(space[1])
        doc.block(align=0)

        for word in """File created successfully : """.split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)
        doc.add(gui.Label(nombre))

        doc.br(space[1])
        
        doc.block(align=0)    
        for word in """Now you can load it with kcontrol to use it""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)

        doc.br(space[1])
        bot= gui.Button("OK")
        bot.connect(gui.CLICK,self.close,None)
        doc.add(bot,align=0)
        doc.br(space[1])


        gui.Dialog.__init__(self,title,doc)

class QuitDialog(gui.Dialog):
    def __init__(self,**params):
        title = gui.Label("Quit")
        
        t = gui.Table()
        
        t.tr()
        t.add(gui.Label("Are you sure you want to quit?"),colspan=2)

        t.tr()
        e = gui.Button("OK")
        e.connect(gui.CLICK,self.send,gui.QUIT)
        t.td(e)
        
        e = gui.Button("Cancel")
        e.connect(gui.CLICK,self.close,None)
        t.td(e)
        
        gui.Dialog.__init__(self,title,t)
        

class WelcomeDialog(gui.Dialog):
    def __init__(self,**params):
        title = gui.Label("Welcome to KSplasher")
        
        doc = gui.Document(width=510)
        
        space = title.style.font.size(" ")

        doc.block(align=0)
        doc.br(space[1])
        doc.add(gui.Image("IMG/logo.png"),align=0)
        doc.br(space[1])
        doc.br(space[1])
        for word in """KDE Moodin Splash Screen Editor and Creator.""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)
        doc.br(space[1])
        doc.br(space[1])
        for word in """We hope you enjoy it. The KSplasher Team.""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)
        doc.br(space[1])
        bot= gui.Button("START")
        bot.connect(gui.CLICK,self.close,None)
        doc.add(bot,align=0)
        doc.br(space[1])


        gui.Dialog.__init__(self,title,doc)

class VarDialog(gui.Dialog):
    def __init__(self,**params):
        title = gui.Label("Align Spacing")
        
        t = gui.Table()
        
        self.value = gui.Form()
        
        t.tr()
        t.td(gui.Label("Enter Icon Spacing: "))
        t.td(gui.Input(name="fname"),colspan=3)
        
        t.tr()
        e = gui.Button("Okay")
        e.connect(gui.CLICK,self.send,gui.CHANGE)
        t.td(e,colspan=2)
        
        e = gui.Button("Cancel")
        e.connect(gui.CLICK,self.close,None)
        t.td(e,colspan=2)
        
        gui.Dialog.__init__(self,title,t)

class UserDialog(gui.Dialog):
    def __init__(self,th,de,ve,au,ho,**params):
        title = gui.Label("Author Information")
        
        t = gui.Table(width=550)
        
        self.value = gui.Form()

        t.tr()
        t.td(gui.Label(""))
        
        
        t.tr()
        t.td(gui.Label("Theme Name: "))
        t.td(gui.Input(value=th,name="tname",size=40),colspan=3)

        t.tr()
        t.td(gui.Label("Description: "))
        t.td(gui.Input(value=de,name="description",size=40),colspan=3)

        t.tr()
        t.td(gui.Label("Version: "))
        t.td(gui.Input(value=ve,name="version",size=40),colspan=3)

        t.tr()
        t.td(gui.Label("Author: "))
        t.td(gui.Input(value=au,name="author",size=40),colspan=3)

        t.tr()
        t.td(gui.Label("Homepage: "))
        t.td(gui.Input(value=ho,name="homepage",size=40),colspan=3)

        t.tr()
        t.td(gui.Label(""))
        
        t.tr()
        e = gui.Button("Okay")
        e.connect(gui.CLICK,self.send,gui.CHANGE)
        t.td(e,colspan=2)
        
        e = gui.Button("Cancel")
        e.connect(gui.CLICK,self.close,None)
        t.td(e,colspan=2)
        
        gui.Dialog.__init__(self,title,t)

