"""<title>Dialogs and Documents</title>
"""
import pygame
from pygame.locals import *

# the following line is not needed if pgu is installed
import sys; sys.path.insert(0, "..")

from pgu import gui

##Documents layout widgets like words and images in a HTML document.  This
##example also demonstrates the ScrollBox container widget.
##::
class AboutDialog(gui.Dialog):
    def __init__(self,**params):
        title = gui.Label("About KSplasher")
        
        doc = gui.Document(width=510)
        
        space = title.style.font.size(" ")

        doc.block(align=0)
        doc.br(space[1])
        doc.add(gui.Image("IMG/logo.png"),align=0)
        doc.br(space[1])
        doc.br(space[1])
        for word in """KDE Moodin Splash Screen Editor and Creator.""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)
        doc.br(space[1])
        doc.br(space[1])
        for word in """Main programmer: Nacho Molina (XaniloM).""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)
        doc.br(space[1])
        for word in """Logo Art by: Divilinux.""".split(" "): 
            doc.add(gui.Label(word))
            doc.space(space)
        doc.br(space[1])
        doc.br(space[1])
        t = gui.Table()
        
        t.tr()
        t.add(gui.Label("Made with help of:"))

        t.tr()
        e = gui.Image("IMG/python.png")
        t.td(e)        
        e = gui.Image("IMG/pygame.png")
        t.td(e)
        e = gui.Image("IMG/pgu.png")
        t.td(e)

        doc.add(t, align=0)
        
        doc.br(space[1])
        bot= gui.Button("CLOSE")
        bot.connect(gui.CLICK,self.close,None)
        doc.add(bot,align=0)
        doc.br(space[1])


        gui.Dialog.__init__(self,title,doc)
        
        
if __name__ in '__main__':
    app = gui.Desktop()
    app.connect(gui.QUIT,app.quit,None)
    
    c = gui.Table(width=640,height=480)
    
    ##The button CLICK event is connected to the dialog.open method.
    ##::
    dialog = AboutDialog()
            
    e = gui.Button("About")
    e.connect(gui.CLICK,dialog.open,None)
    ##
    c.tr()
    c.td(e)
    
    app.run(c)
